"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class VariantCoordinates(ProtocolElement):
    """
    The variant coordinates representing uniquely a small variant.     No
    multi-allelic variant supported, alternate only represents one
    alternate allele.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "alternate",
        "assembly",
        "chromosome",
        "position",
        "reference",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_4 import reports as reports_6_1_0

        return {
            "assembly": reports_6_1_0.Assembly,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_4 import reports as reports_6_1_0

        return {
            "org.gel.models.report.avro.Assembly": reports_6_1_0.Assembly,
            "org.gel.models.report.avro.VariantCoordinates": reports_6_1_0.VariantCoordinates,
        }

    __slots__ = [
        "alternate",
        "assembly",
        "chromosome",
        "position",
        "reference",
    ]

    def __init__(
        self,
        alternate,
        assembly,
        chromosome,
        position,
        reference,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_1_0.VariantCoordinates model.

        :param alternate:
            The alternate bases
        :type alternate: str
        :param assembly:
            The assembly to which this variant corresponds
        :type assembly: Assembly
        :param chromosome:
            Chromosome
        :type chromosome: str
        :param position:
            Genomic position
        :type position: int
        :param reference:
            The reference bases.
        :type reference: str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.1.0"
